SAL3D_API2(pf3dcamera,
        int, pf3dcam_camera_new_cameralink,
        (enum FG_Type type, int fgnum, int portnum, const char *config_file,
         pf3dcam_camera *cam, pf3dcam_error *e DEFZERO),
        (type, fgnum, portnum, config_file, cam, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_camera_new_port,
        (int portnum, const char *config_file,
        pf3dcam_camera *cam,
        pf3dcam_error *e DEFZERO),
        (portnum, config_file, cam, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_camera_new_file,
        (int width, int height, const char *config, pf3dcam_camera *cam,
         pf3dcam_error *e DEFZERO),
        (width, height, config, cam, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_camera_new_gige,
        (const char *config, pf3dcam_camera *cam, pf3dcam_error *e DEFZERO),
        (config, cam, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_camera_get_pflib_port,
        (pf3dcam_camera cam, int *port, pf3dcam_error *e DEFZERO),
        (cam, port, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_camera_get_type,
        (pf3dcam_camera cam, CAM_Type *type, pf3dcam_error *e DEFZERO),
        (cam, type, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_camera_get_iface,
        (pf3dcam_camera cam, CAM_Iface *iface, pf3dcam_error *e DEFZERO),
        (cam, iface, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_camera_sync_config,
        (pf3dcam_camera cam, pf3dcam_error *e DEFZERO),
        (cam, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_camera_grab,
        (pf3dcam_camera cam, pf3dcam_error *e DEFZERO),
        (cam, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_camera_freeze,
        (pf3dcam_camera cam, pf3dcam_error *e DEFZERO),
        (cam, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_camera_wait,
        (pf3dcam_camera cam, int timeout, pf3dcam_error *e DEFZERO),
        (cam, timeout, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_camera_get_raw_frame,
        (pf3dcam_camera cam, int get_current, sal3d_frame *frame,
        pf3dcam_error *e DEFZERO),
        (cam, get_current, frame, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_camera_get_frame,
        (pf3dcam_camera cam, int get_current, sal3d_frame *frame,
        pf3dcam_error *e DEFZERO),
        (cam, get_current, frame, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_camera_get_profile_length,
        (pf3dcam_camera cam, pf3dcam_error *e DEFZERO),
        (cam, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_camera_get_profile,
        (pf3dcam_camera cam, float *profile, int plen, int get_current, int peak,
        pf3dcam_error *e DEFZERO),
        (cam, profile, plen, get_current, peak, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_camera_get_width,
        (pf3dcam_camera cam, float *width, int plen, int get_current, int peak,
	pf3dcam_error *e DEFZERO),
        (cam, width, plen, get_current, peak, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_camera_get_quality,
        (pf3dcam_camera cam, float *quality, int plen, int get_current, int peak,
	pf3dcam_error *e DEFZERO),
        (cam, quality, plen, get_current, peak, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_camera_get_linescan,
        (pf3dcam_camera cam, short *gray, int plen, int get_current, int peak,
	pf3dcam_error *e DEFZERO),
        (cam, gray, plen, get_current, peak, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_camera_get_property_s,
        (pf3dcam_camera cam, const char *prop, char *val, int len,
        pf3dcam_error *e DEFZERO),
        (cam, prop, val, len, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_camera_get_property_i,
        (pf3dcam_camera cam, const char *prop, int *val,
        pf3dcam_error *e DEFZERO),
        (cam, prop, val, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_camera_get_property_f,
        (pf3dcam_camera cam, const char *prop, float *val,
        pf3dcam_error *e DEFZERO),
        (cam, prop, val, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_camera_set_property_s,
        (pf3dcam_camera cam, const char *prop, const char *val,
        pf3dcam_error *e DEFZERO),
        (cam, prop, val, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_camera_set_property_i,
        (pf3dcam_camera cam, const char *prop, int val,
        pf3dcam_error *e DEFZERO),
        (cam, prop, val, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_camera_set_property_f,
        (pf3dcam_camera cam, const char *prop, float val,
        pf3dcam_error *e DEFZERO),
        (cam, prop, val, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_camera_show_window,
        (pf3dcam_camera cam, GIGE_Win win, pf3dcam_error *e DEFZERO),
        (cam, win, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_camera_save_config_file,
        (pf3dcam_camera cam, const char *configfile, pf3dcam_error *e DEFZERO),
        (cam, configfile, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_camera_share,
        (pf3dcam_camera cam, pf3dcam_error *e DEFZERO),
        (cam, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_camera_refcount,
        (pf3dcam_camera cam, pf3dcam_error *e DEFZERO),
        (cam, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_camera_release,
        (pf3dcam_camera cam, pf3dcam_error *e DEFZERO),
        (cam, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_camera_check_validity,
        (pf3dcam_camera cam, pf3dcam_error *e DEFZERO),
        (cam, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_get_num_ports,
        (int *num_ports, pf3dcam_error *e DEFZERO),
        (num_ports, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_open_port,
        (int port, pf3dcam_error *e DEFZERO),
        (port, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_close_port,
        (int port, pf3dcam_error *e DEFZERO),
        (port, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_camera_lost_count,
        (pf3dcam_camera cam, pf3dcam_error *e DEFZERO),
        (cam, e))

SAL3D_API2(pf3dcamera,
        int, pf3dcam_get_dll_version,
        (),
        ())

